from Bio.PDB.PDBParser import PDBParser
from Bio.PDB.Chain import Chain
from Bio.PDB.internal_coords import *
from Bio.PDB.PICIO import write_PIC, read_PIC, read_PIC_seq
from Bio.PDB.ic_rebuild import write_PDB, IC_duplicate, structure_rebuild_test
from Bio.PDB.SCADIO import write_SCAD
from Bio.Seq import Seq
from Bio.PDB import Select
from Bio.SeqRecord import SeqRecord
from Bio.PDB.PDBIO import PDBIO
import numpy as np

rep_atoms = ["N", "CA", "C"]
#select only the backbone coordinates
class select_backbone(Select):
    def __init__(self, atom_list):
        self.atom_list = atom_list
    def accept_atom(self, atom):
        if atom.get_id() in self.atom_list:
            return 1
        else:
            return 0

# Rotate residue by angle
def rotate_res(struct,resid,angle,magnitude):
   for res in struct.get_residues():
      if res.get_id()[1] == resid: 
         # Set internal coordinate
         ph=res.internal_coord.get_angle(angle)
         res.internal_coord.set_angle(angle, ph + magnitude)      
   struct.internal_to_atom_coordinates()
   return struct
   
# Create a Select instance with the atom IDs
my_select = select_backbone(rep_atoms) 
path= '/home/nurith/CS612/homework/hw4/2EZM.pdb'
parser = PDBParser(PERMISSIVE = True, QUIET = True)
ezm = parser.get_structure("EZM", path)
myChain = ezm[0]["A"]
io = PDBIO()
#write_PDB(bb_ezm, "myChain.pdb")
io.set_structure(myChain)
io.save("ezm_bb.pdb",select = select_backbone(rep_atoms))
ezm.atom_to_internal_coordinates(verbose=True)
ezm_40 = rotate_res(ezm,40,'psi',20)
# write new conformation with PDBIO
io.set_structure(ezm_40)
io.save("ezm_bb_t40.pdb",select = select_backbone(rep_atoms))
# rotate back
ezm_40 = rotate_res(ezm,40,'psi',-20)
ezm_101 = rotate_res(ezm,101,'phi',30)
# write new conformation with PDBIO
io.set_structure(ezm_101)
io.save("ezm_bb_t101.pdb",select = select_backbone(rep_atoms))

io.save("ezm_bb_t101.pdb",select = select_backbone(rep_atoms))   

